#!/bin/bash

KYARCH=$(arch)

###chroot
mount --bind /dev /target/dev
mount --bind /proc /target/proc
mount --bind /sys /target/sys

if [ "${KYARCH}" == "aarch64" ];then
  if [ -f /usr/sbin/grub-mkconfig ];then
    echo "${KYARCH}: chroot /target grub-install... "
    chroot /target grub-install
    echo "${KYARCH}: chroot /target grub-mkconfig... "
    chroot /target grub-mkconfig -o /boot/grub/grub.cfg
  fi
fi

umount /target/dev
umount /target/proc
umount /target/sys


###nochroot
if [ "${KYARCH}" == "aarch64" ];then
  if [ -d /target/boot/efi ];then
    if [ -d /cdrom/ESP ];then
      rsync -a /cdrom/ESP/ /target/boot/efi/
    fi

    mkdir -p /target/boot/efi/boot/grub
    cp /target/boot/grub/grub.cfg /target/boot/efi/boot/grub
    cp /target/boot/grub/grub.cfg /target/boot/grub/grub.cfg-old
    GRUB_DEVICE_BOOT=`grub-probe --target=device /target/boot`
    GRUB_ROOT=`grub-probe --device $GRUB_DEVICE_BOOT --target=compatibility_hint`
    GRUB_EFI_CFG="/target/boot/efi/boot/grub/grub.cfg"
    sed -i "s/set root=(\${root})/set root='$GRUB_ROOT'/g" $GRUB_EFI_CFG
    sed -i 's#/uImage console=ttyS0,115200 earlyprintk=uart8250-32bit,0x28001000#/Image#g' $GRUB_EFI_CFG
    sed -i '/devicetree/d' $GRUB_EFI_CFG
    cp /target/boot/efi/boot/grub/grub.cfg /target/boot/grub/grub.cfg
  fi

  if [ -f /target/boot/efi/EFI/kylin/grubaa64.efi ] && [ ! -f /target/boot/efi/EFI/boot/bootaa64.efi ];then
    mkdir -p /target/boot/efi/EFI/boot
    cp /target/boot/efi/EFI/kylin/grubaa64.efi /target/boot/efi/EFI/boot/bootaa64.efi
  fi
fi

if [ "${KYARCH}" == "x86_64" ];then
  if [ -f /target/boot/efi/EFI/kylin/grubx64.efi ] && [ ! -f /target/boot/efi/EFI/boot/bootx64.efi ];then
    mkdir -p /target/boot/efi/EFI/boot
    cp /target/boot/efi/EFI/kylin/grubx64.efi /target/boot/efi/EFI/boot/bootx64.efi
  fi
fi

