#!/bin/bash

# update grub in aarch64
# the ubiquity not configure bootload on aarch64
if [ -f /usr/sbin/grub-mkconfig ]; then
    mount --bind /dev /target/dev
    mount --bind /proc /target/proc
    mount --bind /sys /target/sys
  
    chroot /target grub-mkconfig -o /boot/grub/grub.cfg
  
    umount /target/dev
    umount /target/proc
    umount /target/sys
fi

if [ -d /target/boot/efi ]; then
    if [ -d /cdrom/ESP ]; then
        rsync -a /cdrom/ESP/ /target/boot/efi/
    fi
  
    mkdir -p /target/boot/efi/boot/grub
    cp /target/boot/grub/grub.cfg /target/boot/efi/boot/grub
    GRUB_DEVICE_BOOT=`grub-probe --target=device /target/boot`
    GRUB_ROOT=`grub-probe --device $GRUB_DEVICE_BOOT --target=compatibility_hint`
    GRUB_EFI_CFG="/target/boot/efi/boot/grub/grub.cfg"
    sed -i "s/set root=(\${root})/set root='$GRUB_ROOT'/g" $GRUB_EFI_CFG
    sed -i 's#/uImage#/Image#g' $GRUB_EFI_CFG
    sed -i 's/console=ttyS.,115200 earlyprintk=uart8250-32bit,0x28001000//g' $GRUB_EFI_CFG
    sed -i '/devicetree/d' $GRUB_EFI_CFG
fi
